#
# OTEL v1.0
#
import otel;

sub vcl_recv {			otel.log("entering vcl_recv"); }
sub vcl_deliver {		otel.log("entering vcl_deliver"); }
sub vcl_hit {			otel.log("entering vcl_hit"); }
sub vcl_miss {			otel.log("entering vcl_miss"); }
sub vcl_pass {			otel.log("entering vcl_pass"); }
sub vcl_hash {			otel.log("entering vcl_hash"); }
sub vcl_backend_fetch {		otel.log("entering vcl_backend_fetch"); }
sub vcl_backend_response {	otel.log("entering vcl_backend_response"); }
sub vcl_backend_error {		otel.log("entering vcl_backend_error"); }
sub vcl_synth {			otel.log("entering vcl_synth"); }
sub vcl_pipe {			otel.log("entering vcl_pipe"); }
sub vcl_connect {		otel.log("entering vcl_connect"); }

sub vcl_recv {
	set req.http.tracestate = req.http.tracestate;
	if (req.restarts == 0) {
		set req.http.traceparent = otel.generate(req_top.http.traceparent);
	}
}

sub vcl_backend_fetch {
	if (!otel.validate(bereq.http.traceparent)) {
		return (fail);
	} else {
		set bereq.http.traceparent = otel.generate(bereq.http.traceparent);
	}
}
